<template>
    <div id="Consultation">
        <div class="text-center">
            <h1>Consultation</h1>
            <router-link :to="{name: 'newElementListe', params: {id: $route.params.id}}">
                <button type="button" class="btn btn-primary">Nouvel element</button>
            </router-link>
        </div>
        <div class="container text-center mt-3">
            <div class="mt-2 row justify-content-md-center">
                <div class="col-4"><b>libelle</b></div>
                <div class="col-4">{{ element.libelle }}</div>
            </div>
            <div class="mt-2 row justify-content-md-center">
                <div class="col-4"><b>Description</b></div>
                <div class="col-4">{{ element.description }}</div>
            </div>
            <div class="mt-2 row justify-content-md-center">
                <div class="col-4"><b>Total</b></div>
                <div class="col-4">{{ total }}</div>
            </div>
        </div>

        <div class="text-center">
            <h3>Liste des items</h3>
        </div>

        <div class="row justify-content-md-center">
            <div class="col-8">
                <ul class="list-group">
                    <li class="list-group-item" v-for="(item, index) in element.items" :key="index">
                        <div class="row">
                            <div class="col-3">
                                <h5><b>libelle: </b> {{ item.libelle }}</h5>
                            </div>
                            <div class="col-3">
                                <h5><b>Prix: </b> {{ item.prix }}</h5>
                            </div>
                            <div class="col-3">
                                <h5><b>Description: </b> {{ item.description }}</h5>
                            </div>
                            <div class="col-3">
                                <button type="button" class="btn btn-danger" @click="removeItemFromListe(item.id)">Supprimer</button>
                            </div>
                        </div>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'Consultation',
        data: ()=>  ({
            element: {}
        }),
        computed: {
            total : function() {
                let val = 0;

                if(this.element.items){
                    val = this.element.items.length
                }
                return val;
            }
        },
        mounted() {

            //Récupération de la liste à consulter
            let id = this.$route.params.id;
            let objs = JSON.parse(localStorage.getItem('listes'));

            let currentItem;
            objs.forEach(function(item){
                if(item.id == id){
                    currentItem = item;
                }
            });

            this.element = currentItem;
        },
        methods: {
            removeItemFromListe(idItem){

                //Récupération de l'ID de l'item
                const index = this.element.items.findIndex(list => list.id === idItem);

                //Suppression de l'item de la liste
                this.element.items.splice(index, 1);

                //On reset l'ensemble des listes avec l'item en moins pour la bonne liste
                let id = this.$route.params.id;
                let objs = JSON.parse(localStorage.getItem('listes'));
                let indexObj = objs.findIndex(list => list.id === id);

                objs[indexObj] = this.element;

                localStorage.setItem('listes', JSON.stringify(objs));


            }
        }
    }
</script>